polybori::CVariableIter< Iterator, VariableType > Class Template Reference

This template class defines an iterator for monomial types. More...

`#include <CVariableIter.h>`

Inheritance diagram for polybori::CVariableIter< Iterator, VariableType >:

## Public Types

typedef Iterator | iterator_type
| Fixing Iterator type to be extended. More...
typedef VariableType | var_type
| Fixing variables, which is used for dereferencing. More...
typedef var_type::ring_type | ring_type
| Fixing ring, which is used to generate variables. More...
typedef CVariableIter< iterator_type, var_type > | self
| Get type of *this. More...

## Public Member Functions

| CVariableIter ()
| Default constructor. More...
| CVariableIter (const iterator_type &rhs, const ring_type &ring)
| Constructor for given iterator (and ring) More...
bool | isEnd () const
| Check, whether end of iteration is reached. More...
void | increment ()
| Increment operation. More...
var_type | dereference () const
| Constant dereference operator. More...
bool | equal (const self &rhs) const
| Equality check. More...

## Detailed Description

### template<class Iterator, class VariableType>
class polybori::CVariableIter< Iterator, VariableType >

This template class defines an iterator for monomial types.

It uses a given iterator, and converts indices to Boolean variables (via a given ring).

## Member Typedef Documentation

template<class Iterator , class VariableType >

typedef Iterator polybori::CVariableIter< Iterator, VariableType >::iterator_type

Fixing Iterator type to be extended.

template<class Iterator , class VariableType >

typedef var_type::ring_type polybori::CVariableIter< Iterator, VariableType >::ring_type

Fixing ring, which is used to generate variables.

template<class Iterator , class VariableType >

typedef CVariableIter<iterator_type, var_type> polybori::CVariableIter< Iterator, VariableType >::self

Get type of *this.

template<class Iterator , class VariableType >

typedef VariableType polybori::CVariableIter< Iterator, VariableType >::var_type

Fixing variables, which is used for dereferencing.

## Constructor & Destructor Documentation

template<class Iterator , class VariableType >

polybori::CVariableIter< Iterator, VariableType >::CVariableIter | ( |  | ) |

inline

Default constructor.

template<class Iterator , class VariableType >

polybori::CVariableIter< Iterator, VariableType >::CVariableIter | ( | const iterator_type & | rhs,
|  | const ring_type & | ring
| ) |  |

inline

Constructor for given iterator (and ring)

## Member Function Documentation

template<class Iterator , class VariableType >

var_type polybori::CVariableIter< Iterator, VariableType >::dereference | ( |  | ) | const

inline

Constant dereference operator.

template<class Iterator , class VariableType >

bool polybori::CVariableIter< Iterator, VariableType >::equal | ( | const self & | rhs | ) | const

inline

Equality check.

template<class Iterator , class VariableType >

void polybori::CVariableIter< Iterator, VariableType >::increment | ( |  | ) |

inline

Increment operation.

template<class Iterator , class VariableType >

bool polybori::CVariableIter< Iterator, VariableType >::isEnd | ( |  | ) | const

inline

Check, whether end of iteration is reached.

The documentation for this class was generated from the following file:

- CVariableIter.h